:-
:-  buildlcc.bat autobuild script, should be fairly bulletproof
:-  Builds lcc 4.1 for use with GNU make for DOS and NASM assembler
:-  Rob Judd <judd@alphalink.com.au>  98/12/02 revised 98/12/09
:-

@echo off
:-  Check for existence of LCCDIR environment variable
:-  (Can't check the actual contents from here)

if .%LCCDIR%==. goto enverror

:-  Copy src/rcc.asdl to a file with 8.3 name for DJGPP make
if not exist src\rcc.asd copy src\rcc.asdl src\rcc.asd

:-  Check for headers in standard include-directory location
if not exist include\stdio.h copy include\x86\nasmwin\*.* include

:-  Check existence of 0-length files in the tst directory
:-  Fixes piss-poor archivers which can't extract 0-length files
if exist 8q.0 goto start
echo "" > tst\8q.0
echo "" > tst\array.0
echo "" > tst\cq.0
echo "" > tst\cvt.0
echo "" > tst\fields.0
echo "" > tst\front.0
echo "" > tst\incr.0
echo "" > tst\init.0
echo "" > tst\limits.0
echo "" > tst\paranoia.0
echo "" > tst\sort.0
echo "" > tst\spill.0
echo "" > tst\stdarg.0
echo "" > tst\struct.0
echo "" > tst\switch.0
echo "" > x86\nasmwin\tst\incr.1bk
echo "" > x86\nasmwin\tst\spill.1bk

:start
if "%1"=="" goto doit
if "%1"=="all" goto doit
if "%1"=="test" goto test
if "%1"=="triple" goto triple

:- Something else was entered, duh.
echo Usage: buildlcc [option]
echo [option] can be: all, test or triple. No option == all
echo .
echo If you want something else, try "make -f makefile.lcc [option]" (but it's flakey)
goto end

:doit
echo .
echo Making lcc 4.1
echo .
make -f makefile.lcc all
echo .
echo Ready to build LIBRCC.LIB, hit enter to continue or CTL-C to exit
pause
echo Rolling ...
echo .

:rcc
:- Build the rcc library
copy librcc.lst build
cd build
if exist librcc.lib del librcc.lib
:- This kills a stupid "Cannot open file" warning from lcclib
echo "" > librcc.lib
lcclib librcc.lib @librcc.lst
cd ..
echo .
echo Ready to build RCC.EXE, hit enter to continue or CTL-C to exit
pause
echo .
make -f makefile.lcc all

:cpp
echo Building cpp.exe
copy cpp.lst build
cd build
lcclnk -s -subsystem console -o cpp.exe @cpp.lst
cd..
echo .
echo CPP.EXE built, hit enter to continue or CTL-C to exit
pause
echo .
:- Build the rest of it
make -f makefile.lcc all

:transfer
:-  Just copy 'em, no easy way to see whether they're all built
echo .
echo LCC 4.1 complete, transferring files to local bin directory
echo .
copy build\*.exe bin
copy build\liblcc.lib bin

:- Don't rebuild unless asked specifically
if exist build\x86\nasmwin\yacc.exe goto triple
:test
:- Check to make sure the sucker is built first ...
if not exist build\x86nasmw.obj goto doit
echo .
echo Compiling the test programs
echo .
echo y | del build\x86\nasmwin\*.* > nul
if exist paranoia.s copy paranoia.s build\x86\nasmwin
make -f makefile.lcc test
echo .
echo TEST built, hit enter to continue or CTL-C to exit
pause
echo .

:- Don't rebuild unless asked specifically
if not exist build\1rcc.exe goto triple
if exist build\2rcc.exe goto finished
:triple
:- Check to make sure the sucker is built first ...
if not exist build\x86nasmw.obj goto doit
echo .
echo Running the triple test
echo .
bin\lcc -A -d0.6 -Isrc -Ibuild -o build\1rcc.exe -Bbuild\ src/alloc.c src/bind.c src/dag.c src/decl.c src/enode.c src/error.c src/expr.c src/event.c src/init.c src/inits.c src/input.c src/lex.c src/list.c src/main.c src/output.c src/prof.c src/profio.c src/simp.c src/stmt.c src/string.c src/sym.c src/trace.c src/tree.c src/types.c src/null.c src/symbolic.c src/bytecode.c src/gen.c src/stab.c build/dagcheck.c build/alpha.c build/mips.c build/sparc.c build/x86linux.c build/x86.c build/x86nasmw.c
bin\lcc -A -d0.6 -Isrc -Ibuild -o build\2rcc.exe -Bbuild\ src/alloc.c src/bind.c src/dag.c src/decl.c src/enode.c src/error.c src/expr.c src/event.c src/init.c src/inits.c src/input.c src/lex.c src/list.c src/main.c src/output.c src/prof.c src/profio.c src/simp.c src/stmt.c src/string.c src/sym.c src/trace.c src/tree.c src/types.c src/null.c src/symbolic.c src/bytecode.c src/gen.c src/stab.c build/dagcheck.c build/alpha.c build/mips.c build/sparc.c build/x86linux.c build/x86.c build/x86nasmw.c
fc /B build\1rcc.exe build\2rcc.exe

:finished
echo .
echo Finished!
goto end

:enverror
echo Please set the environment variable LCCDIR to the current path
echo Example: set LCCDIR=\lcc\4.1

:end
@echo on
