/* x86s running MS Windows NT 4.0
 * Rob Judd  98/11/13  Standard path setups assume the binaries are in the path.
 *                     LCCDIR is the "home directory" of lcc, one level above bin.
 *                     Furthermore include, bin and lib are usually at the same level.
 *
 *                     Note: argument order $1, $2, $3 corresponds to 
 *                     options, input, output respectively.
 *
 */

#include <string.h>

static char rcsid[] = "$Id: nasmwin.c,v 0.30 1998/11/13 21:40:50 rj Exp $";

#ifndef LCCDIR
#define LCCDIR "\\lang\\lcc\\4.1"
#endif

char *suffixes[] = { ".c;.C", ".i;.I", ".asm;.ASM;.s;.S", ".obj;.OBJ", ".exe", 0 };
char inputs[256] = "";
char *cpp[] = { "cpp", "-D__STDC__=1", "-Dwin32", "-D_WIN32", "-D_M_IX86", \
			"$1", "$2", "$3", 0 };
char *include[] = { "-I" LCCDIR "\\include\\x86\\nasmwin", 0 };
char *com[] = { "rcc", "-win32", "-target=x86/nasmwin", "$1", "$2", "$3", 0 };
/*  Must NOT have -a (inhibit input validation) or assembler throws bogus errors  */
char *as[] = { "nasmw", "-f win32", "$1", "-o", "$3", "$2", 0 };
/*  Options to linker will usually be libraries, which must be on the end   */
char *ld[] = { "lcclnk", "-s -subsystem console", "-o $3", "$2", "$1", \
		LCCDIR "\\bin\\liblcc.lib", 0 };

extern char *concat(char *, char *);
extern char *replace(const char *, int, int);

int option(char *arg) {
	if (strncmp(arg, "-lccdir=", 8) == 0) {
		arg = replace(arg + 8, '/', '\\');
		if (arg[strlen(arg)-1] == '\\')
			arg[strlen(arg)-1] = '\0';              /*  Chop off trailing slashes  */
		cpp[0] = concat(arg, "\\bin\\cpp.exe");
		include[0] = concat("-I", concat(arg, "\\include"));
		com[0] = concat(arg, "\\bin\\rcc.exe");
		ld[5]  = concat(arg, "\\bin\\liblcc.lib");     /*  Compiler-specific library  */
	} else if (strcmp(arg, "-b") == 0)
		;
	else if (strncmp(arg, "-as=", 4) == 0)              /*  Replaceable assembler      */
		as[0] = &arg[4];
	else if (strncmp(arg, "-ld=", 4) == 0)              /*  Replaceable linker         */
		ld[0] = &arg[4];
	else
		return 0;
	return 1;
}
